# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`rsyslog`](#rsyslog): Set up rsyslog 7  The configuration is particularly slanted toward the issues present in the version of rsyslog included with Enterprise Linu
* [`rsyslog::config`](#rsyslogconfig): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Setup RSyslog configuration. - When the 
* [`rsyslog::config::logrotate`](#rsyslogconfiglogrotate): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Default log rotation for RSyslog  The li
* [`rsyslog::install`](#rsysloginstall): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Installs the packages necessary for use 
* [`rsyslog::params`](#rsyslogparams): A list of the parameters and their default values for RSyslog.
* [`rsyslog::server`](#rsyslogserver): Sets up the RSyslog server  This class is designed to configure the externally facing interfaces for a RSyslog system. If you do not need ext
* [`rsyslog::server::firewall`](#rsyslogserverfirewall): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Sets up the firewall rules for RSyslog w
* [`rsyslog::server::selinux`](#rsyslogserverselinux): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Sets up SELinux for RSyslog  Switches on
* [`rsyslog::server::tcpwrappers`](#rsyslogservertcpwrappers): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Sets up TCPWrappers for RSyslog both pla
* [`rsyslog::service`](#rsyslogservice): **NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**  Manage the RSyslog service

**Defined types**

* [`rsyslog::rule`](#rsyslogrule): Adds a rule  This is used by the various ``rsyslog::rule::*`` Defined Types to apply rules to the system.  Feel free to use this Defined Type
* [`rsyslog::rule::console`](#rsyslogruleconsole): Add a rule for writing logs to the console  These rules first in priority. In general, the order will be:    * Data Source Rules   * Console 
* [`rsyslog::rule::data_source`](#rsyslogruledata_source): Add a rule for collecting logs from files on the system  In general, the order will be:    * Data Source Rules   * Console Rules   * Drop Rul
* [`rsyslog::rule::drop`](#rsyslogruledrop): Add a rule to drop content  In general, the order will be:    * Data Source Rules   * Console Rules   * Drop Rules   * Remote Rules   * Other
* [`rsyslog::rule::local`](#rsyslogrulelocal): Add a rule targeting writing local system logs  **NOTE:** Any option that is not explicitly documented here matches the ``ruleset`` options i
* [`rsyslog::rule::other`](#rsyslogruleother): Adds an arbitrary rule  The main reason to use this is to ensure proper ordering in the stack. If you want to insert a rule anywhere, use the
* [`rsyslog::rule::remote`](#rsyslogruleremote): Adds a rule to send messages to a remote system  In general, the order will be:    * Data Source Rules   * Console Rules   * Drop Rules   * R
* [`rsyslog::template::list`](#rsyslogtemplatelist): Add a template list to the rsyslog configuration file.  RSyslog list templates can contain properties and constants. In order to capture this
* [`rsyslog::template::plugin`](#rsyslogtemplateplugin): Add template plugins to the rsyslog configuration file.  **NOTE:** Plugins are **as-is**. This means that you will only supply the plugin nam
* [`rsyslog::template::string`](#rsyslogtemplatestring): Add template strings to the rsyslog configuration  You'll need to write the entire template line due to the complexity of the rsyslog configu
* [`rsyslog::template::subtree`](#rsyslogtemplatesubtree): Add template subtrees to the rsyslog configuration  You'll need to write the entire subtree line due to the complexity of the rsyslog configu

## Classes

### rsyslog

Set up rsyslog 7

The configuration is particularly slanted toward the issues present in the
version of rsyslog included with Enterprise Linux systems. It should still
work on other systems but they may have different/other bugs that have not
been addressed.

#### Parameters

The following parameters are available in the `rsyslog` class.

##### `service_name`

Data type: `String`

The name of the RSyslog service; typically ``rsyslog``

Default value: $::rsyslog::params::service_name

##### `package_name`

Data type: `String`

The name of the Rsyslog package to install; typically ``rsyslog``

Default value: $::rsyslog::params::package_name

##### `tls_package_name`

Data type: `String`

The name of the Rsyslog package to install TLS utilities; typically ``rsyslog-gnutls``

Default value: $::rsyslog::params::tls_package_name

##### `trusted_nets`

Data type: `Simplib::Netlist`

A whitelist of subnets (in CIDR notation) permitted access

* This will be used in conjunction with IPTables (if enabled)
  to allow connections from within the given subnets.

Default value: simplib::lookup('simp_options::trusted_nets', {'default_value'                  => ['127.0.0.1/32'] })

##### `enable_tls_logging`

Data type: `Boolean`

Enable the TLS libraries where applicable

* If enabled, clients will encrypt all log data being sent to the given log
  servers.  Also, all log servers specified to use TLS (see
  ``rsyslog::server::tls_tcp_server``) will load the ``imtcp`` libraries
  and set the necessary global ``NetStreamDriver`` information.

Default value: `false`

##### `log_servers`

Data type: `Simplib::Netlist`

A list of primary RSyslog servers

* All nodes in this list will get a copy of **all** logs if remote logging
  is enabled.

Default value: simplib::lookup('simp_options::syslog::log_servers', { 'default_value'          => [] })

##### `failover_log_servers`

Data type: `Simplib::Netlist`

A list of the failover RSyslog servers

* This **order-dependent** list will serve as all of the possible failover
  log servers for clients to send to if the servers in ``log_servers`` are
  unavailable.

Default value: simplib::lookup('simp_options::syslog::failover_log_servers', { 'default_value' => [] })

##### `queue_spool_directory`

Data type: `Stdlib::Absolutepath`

The path to the directory where RSyslog should store disk message queues

Default value: '/var/spool/rsyslog'

##### `rule_dir`

Data type: `Stdlib::Absolutepath`

The path at which all managed rules will begin

Default value: '/etc/rsyslog.simp.d'

##### `tcp_server`

Data type: `Boolean`

Make this host listen for ``TCP`` connections

* Ideally, all connections would be ``TLS`` enabled. Only enable this if
  necessary.

Default value: `false`

##### `tcp_listen_port`

Data type: `Simplib::Port`

The port upon which to listen for regular ``TCP`` connections

Default value: 514

##### `tls_tcp_server`

Data type: `Boolean`

Make this host listen for ``TLS`` enabled ``TCP`` connections

Default value: `false`

##### `tls_tcp_listen_port`

Data type: `Simplib::Port`

The port upon which to listen for ``TLS`` enabled ``TCP`` connections

Default value: 6514

##### `udp_server`

Data type: `Boolean`

Make this host listend for ``UDP`` connections

* This really should not be enabled unless you have devices that cannot
  speak ``TLS`` @param enable_logrotate

Default value: `false`

##### `udp_listen_address`

Data type: `String`

The address upon which to listen for ``UDP`` connections

* The default of ``127.0.0.1`` is set primariliy for supporting Java
  applications that cannot work with a modern method of logging.

Default value: '127.0.0.1'

##### `udp_listen_port`

Data type: `Simplib::Port`

The port upon which to listen for ``UDP`` connections

Default value: 514

##### `read_journald`

Data type: `Boolean`

Enable the processing of ``journald`` messages natively in Rsyslog

Default value: $::rsyslog::params::read_journald

##### `logrotate`

Data type: `Boolean`

Ensure that ``logrotate`` is enabled on this system

* You will need to configure specific logrotate settings via the
``logrotate`` module.

Default value: simplib::lookup('simp_options::logrotate', {'default_value'                     => false})

##### `pki`

Data type: `Variant[Boolean,Enum['simp']]`

* If 'simp', include SIMP's pki module and use pki::copy to manage
  application certs in /etc/pki/simp_apps/rsyslog/x509
* If true, do *not* include SIMP's pki module, but still use pki::copy
  to manage certs in /etc/pki/simp_apps/rsyslog/x509
* If false, do not include SIMP's pki module and do not use pki::copy
  to manage certs.  You will need to appropriately assign a subset of:
  * app_pki_dir
  * app_pki_key
  * app_pki_cert
  * app_pki_ca
  * app_pki_ca_dir

Default value: simplib::lookup('simp_options::pki', {'default_value'                           => false})

##### `app_pki_external_source`

Data type: `Stdlib::Absolutepath`

* If pki = 'simp' or true, this is the directory from which certs will be
  copied, via pki::copy.  Defaults to /etc/pki/simp/x509.

* If pki = false, this variable has no effect.

Default value: simplib::lookup('simp_options::pki::source', {'default_value'                   => '/etc/pki/simp/x509'})

##### `app_pki_dir`

Data type: `Stdlib::Absolutepath`

Basepath of $default_net_stream_driver_ca_file, default_net_stream_driver_cert_file,
and $default_net_stream_driver_key_file

Default value: '/etc/pki/simp_apps/rsyslog/x509'

### rsyslog::config

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Setup RSyslog configuration.
- When the host uses systemd, creates a rsyslog.service override file
  that fixes a service ordering problem present with  older versions
  of rsyslog.
- Creates /etc/rsyslog.conf and includes all SIMP config subdirectories
  in /etc/rsyslog.simp.d.

**NOTE** Any undocumented parameters map directly to their counterparts in
the Rsyslog configuration files.

#### Parameters

The following parameters are available in the `rsyslog::config` class.

##### `umask`

Data type: `String`

The umask that should be applied to the running process

Default value: '0027'

##### `localhostname`

Data type: `String`

The Hostname that should be used on your syslog messages

Default value: $facts['fqdn']

##### `preserve_fqdn`

Data type: `Boolean`

Ensure that the ``fqdn`` of the originating host is preserved in all log
messages

Default value: `true`

##### `control_character_escape_prefix`

Data type: `String[1,1]`



Default value: '#'

##### `drop_msgs_with_malicious_dns_ptr_records`

Data type: `Enum['off','on']`



Default value: 'off'

##### `escape_control_characters_on_receive`

Data type: `Enum['off','on']`



Default value: 'on'

##### `default_template`

Data type: `String`

The default template to use to output to various services

* The provided template has been designed to work with external parsing
  tools that require the priority text

* You can also choose from the following values in order to select from one
  of the built-in rsyslogd formats.

    * forward     -> RSYSLOG_Forward
    * original    -> RSYSLOG_FileFormat
    * traditional -> RSYSLOG_TraditionalFileFormat

Default value: 'original'

##### `syssock_ignore_timestamp`

Data type: `Boolean`



Default value: `true`

##### `syssock_ignore_own_messages`

Data type: `Boolean`



Default value: `true`

##### `syssock_use`

Data type: `Boolean`



Default value: `true`

##### `syssock_name`

Data type: `Optional[String]`



Default value: `undef`

##### `syssock_flow_control`

Data type: `Boolean`



Default value: `false`

##### `syssock_use_pid_from_system`

Data type: `Boolean`



Default value: `false`

##### `syssock_rate_limit_interval`

Data type: `Integer[0]`



Default value: 0

##### `syssock_rate_limit_burst`

Data type: `Integer[0]`



Default value: 1000

##### `syssock_rate_limit_severity`

Data type: `Integer[0]`



Default value: 5

##### `syssock_use_sys_timestamp`

Data type: `Boolean`



Default value: `true`

##### `syssock_annotate`

Data type: `Boolean`



Default value: `false`

##### `syssock_parse_trusted`

Data type: `Boolean`



Default value: `false`

##### `syssock_unlink`

Data type: `Boolean`



Default value: `true`

##### `main_msg_queue_type`

Data type: `Enum['LinkedList','FixedArray']`

The type of queue that will be used

* It is **highly** recommended that you leave this as ``LinkedList`` unless
  you really know what you are doing.

Default value: 'LinkedList'

##### `main_msg_queue_filename`

Data type: `String`



Default value: 'main_msg_queue'

##### `main_msg_queue_size`

Data type: `Optional[Integer[0]]`

The size of the main (global) message queue

* By default, the minimum of 1% of physical memory or 1G, based on a 512B
  message size. The maximum number of messages that may be stored in the
  memory queue.

Default value: `undef`

##### `main_msg_queue_high_watermark`

Data type: `Optional[Integer[0]]`

The point at which the queue will start writing messages to disk as a
number of messages

* By default, 90% of ``$main_msg_queue_size``

Default value: `undef`

##### `main_msg_queue_low_watermark`

Data type: `Optional[Integer[0]]`

The point at which the queue will stop writing messages to disk as a number
of messages

* **NOTE:** This must be **lower** than ``$main_msg_queue_high_watermark``
* By default, 70% of ``$main_msg_queue_size``

Default value: `undef`

##### `main_msg_queue_discardmark`

Data type: `Optional[Integer[0]]`

The point at which the queue will discard messages

* By default, 98% of ``$main_msg_queue_size``

Default value: `undef`

##### `main_msg_queue_worker_thread_minimum_messages`

Data type: `Optional[Integer[0]]`

The minimum number of messages in the queue before a new thread can be
spawned

* If left empty (the default), will calculate the value based on the
  following formula: ``$main_msg_queue_size/(($processorcount - 1)*4)``

Default value: `undef`

##### `main_msg_queue_worker_threads`

Data type: `Optional[Integer[0]]`

The maximum number of threads to spawn on the system

* By default, ``$processorcount - 1``

Default value: `undef`

##### `main_msg_queue_worker_timeout_thread_shutdown`

Data type: `Integer[0]`



Default value: 5000

##### `main_msg_queue_timeout_enqueue`

Data type: `Integer[0]`



Default value: 100

##### `main_msg_queue_dequeue_slowdown`

Data type: `Integer[0]`



Default value: 0

##### `main_msg_queue_save_on_shutdown`

Data type: `Enum['on','off']`



Default value: 'on'

##### `main_msg_queue_max_disk_space`

Data type: `Optional[Integer[0]]`

The maximum amount of disk space to use for the disk queue.

* Specified as a digit followed by a unit specifier. For example:

    * 100   -> 100 Bytes
    * 100K  -> 100 Kilobytes
    * 100M  -> 100 Megabytes
    * 100G  -> 100 Gigabytes
    * 100T  -> 100 Terabytes
    * 100P  -> 100 Petabytes

* If not specified, will default to ``$main_msg_queue_size * 1024``

Default value: `undef`

##### `main_msg_queue_max_file_size`

Data type: `Integer[0]`

The maximum file size, in Megabytes, that should be created when buffering
to disk.

* **NOTE:** It is not recommended to make this excessively large

Default value: 5

##### `repeated_msg_reduction`

Data type: `Enum['on','off']`



Default value: 'on'

##### `work_directory`

Data type: `Stdlib::Absolutepath`



Default value: '/var/spool/rsyslog'

##### `interval`

Data type: `Integer[0]`

The ``mark`` interval

Default value: 0

##### `tls_tcp_max_sessions`

Data type: `Integer[0]`

The maximum number of sessions to support

Default value: 200

##### `tls_input_tcp_server_stream_driver_permitted_peers`

Data type: `Array[String]`

A *wildcard-capable* Array of domains that should be allowed to talk to the
server over ``TLS``

Default value: ["*.${::domain}"]

##### `default_net_stream_driver`

Data type: `Enum['gtls','ptcp']`



Default value: 'gtls'

##### `default_net_stream_driver_ca_file`

Data type: `Stdlib::Absolutepath`



Default value: "${::rsyslog::app_pki_dir}/cacerts/cacerts.pem"

##### `default_net_stream_driver_cert_file`

Data type: `Stdlib::Absolutepath`



Default value: "${::rsyslog::app_pki_dir}/public/${::fqdn}.pub"

##### `default_net_stream_driver_key_file`

Data type: `Stdlib::Absolutepath`



Default value: "${::rsyslog::app_pki_dir}/private/${::fqdn}.pem"

##### `action_send_stream_driver_mode`

Data type: `Enum['1','0']`



Default value: (

##### `action_send_stream_driver_auth_mode`

Data type: `Optional[String]`



Default value: `undef`

##### `action_send_stream_driver_permitted_peers`

Data type: `Array[String]`



Default value: $::rsyslog::log_servers

##### `ulimit_max_open_files`

Data type: `Variant[Enum['unlimited'],Integer[0]]`

The maximum open files limit that should be set for the syslog server

* ``1024`` is fine for most purposes, but a collection server should bump this
  **way** up.

Default value: 'unlimited'

##### `host_list`

Data type: `Array[String]`

Hosts that should be logged with their simple hostname

* See the ``-l`` option in ``rsyslogd(8)`` for more information

Default value: []

##### `domain_list`

Data type: `Array[String]`

Array of domains that should be stripped off before logging

* See the ``-s`` option in ``rsyslogd(8)`` for more information

Default value: []

##### `suppress_noauth_warn`

Data type: `Boolean`

Suppress warnings due to hosts not in the ACL

* See the ``-w`` option in ``rsyslogd(8)`` for more information

Default value: `false`

##### `disable_remote_dns`

Data type: `Boolean`

Disable DNS lookups for remote messages

* See the ``-x`` option in ``rsyslogd(8)`` for more information

Default value: `false`

##### `enable_default_rules`

Data type: `Boolean`

Enables default rules for logging common services (e.g., iptables, puppet, slapd_auditd)

Default value: `true`

##### `read_journald`

Data type: `Boolean`

Enable the forwarding of the ``systemd`` journal to syslog

Default value: $::rsyslog::read_journald

##### `include_rsyslog_d`

Data type: `Boolean`

Include all configuration files in the system-standard ``/etc/rsyslog.d``

* This will place the configuration files **after** the global
  configuration but **before** the SIMP applied configurations.

Default value: `false`

##### `systemd_override_file`

Data type: `String`

The basename of the systemd override file for the rsyslog service

Default value: 'unit.conf'

### rsyslog::config::logrotate

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Default log rotation for RSyslog

The list that is managed here matches the list of default files that are
managed on the system by this module.

#### Parameters

The following parameters are available in the `rsyslog::config::logrotate` class.

##### `rotate_period`

Data type: `Enum['daily','weekly','monthly','yearly']`

How often to rotate the logs

Default value: 'daily'

##### `rotate_preserve`

Data type: `Integer[0]`

How many rotated logs to keep

Default value: 7

##### `rotate_size`

Data type: `Optional[Integer[0]]`

The maximum size of a log file

* ``$rotate_period`` will be ignored if this is specified

Default value: `undef`

### rsyslog::install

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Installs the packages necessary for use of RSyslog

#### Parameters

The following parameters are available in the `rsyslog::install` class.

##### `ensure`

Data type: `String`

How to install the packages

* Accepts the same values as the ``Package`` resource's ``ensure``
  parameter

Default value: 'latest'

### rsyslog::params

A list of the parameters and their default values for RSyslog.

#### Parameters

The following parameters are available in the `rsyslog::params` class.

##### `service_name`

Data type: `String`

The name of the rsyslog service

##### `package_name`

Data type: `String`

The name of the rsyslog package

##### `tls_package_name`

Data type: `String`

The name of the rsyslog package providing GNUTLS support

##### `read_journald`

Data type: `Boolean`

Tie in the reading of ``journald`` if available

### rsyslog::server

Sets up the RSyslog server

This class is designed to configure the externally facing interfaces for a
RSyslog system. If you do not need external connectivity, you should just use
the stock ``::rsyslog`` Class.

#### Parameters

The following parameters are available in the `rsyslog::server` class.

##### `enable_firewall`

Data type: `Boolean`

Enable the SIMP firewall rules for RSyslog

Default value: simplib::lookup('simp_options::firewall', { 'default_value' => false })

##### `enable_selinux`

Data type: `Optional[Boolean]`

Enable the SIMP SELinux rules for RSyslog

Default value: $facts['selinux_enforced']

##### `enable_tcpwrappers`

Data type: `Boolean`

Enable the SIMP TCPWrapper rules for RSyslog

Default value: simplib::lookup('simp_options::tcpwrappers', { 'default_value' => false })

### rsyslog::server::firewall

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Sets up the firewall rules for RSyslog with IPTables

In ports will be openened for all systems inside of the
``$::rsyslog::trusted_nets`` Array.

### rsyslog::server::selinux

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Sets up SELinux for RSyslog

Switches on the ``nis_enabled`` SELinux Boolean since this is required for
successful RSyslog connections.

* **Note** This **MAY** not be necessary any longer and should be validated

### rsyslog::server::tcpwrappers

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Sets up TCPWrappers for RSyslog both plain TCP and TCP over TLS as necessary

**NOTE:** This actually **opens** the TCPWrappers rules for RSyslog since
testing has shown that it was prone to some odd connectivity errors. Both
IPTables and an internal allow list protect RSyslog connections.

### rsyslog::service

**NOTE: THIS IS A [PRIVATE](https://github.com/puppetlabs/puppetlabs-stdlib#assert_private) CLASS**

Manage the RSyslog service

#### Parameters

The following parameters are available in the `rsyslog::service` class.

##### `enable`

Data type: `Boolean`

Enable the rsyslog service

Default value: `true`

## Defined types

### rsyslog::rule

Adds a rule

This is used by the various ``rsyslog::rule::*`` Defined Types to apply rules
to the system.

Feel free to use this Defined Type to add your own rules but remember that
**order matters**!

In general, the order will be:

  * 05 - Data Source Rules
  * 06 - Console Rules
  * 07 - Drop Rules
  * 10 - Remote Rules
  * 20 - Other/Miscellaneous Rules
  * 99 - Local Rules

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

#### Examples

##### Collect All ``kern.err`` Messages

```puppet
rsyslog::rule { '99_collect_kernel_errors.conf':
  rule =>  "if prifilt('kern.err') then /var/log/kernel_errors.log"
}
```

##### Discard All ``info`` Messages

```puppet
rsyslog::rule::other { '98_discard_info.conf':
  rule =>  "if prifilt('*.info') then stop"
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule` defined type.

##### `name`

Data type: `Pattern['^[^/]\S+/\S+\.conf$']`

The filename that you will be dropping into place

* **WARNING:** This must **NOT** be an absolute path!

##### `content`

Data type: `String`

The **exact content** of the rule to place in the target file

### rsyslog::rule::console

Add a rule for writing logs to the console

These rules first in priority. In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellaneous Rules
  * Local Rules

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

#### Examples

##### Log Emergency Messages to the Console

```puppet
rsyslog::rule::console { 'emergency_rule':
  rule  => 'prifilt(\'*.emerg\'),
  users => ['*']
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::console` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `String`

The Rsyslog ``EXPRESSION`` to filter on

##### `users`

Data type: `Array[String]`

Users to which to send the console messages

### rsyslog::rule::data_source

Add a rule for collecting logs from files on the system

In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellaneous Rules
  * Local Rules

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

The filename that you will be dropping into place.

#### Examples

##### Collect Logs From ``/opt/log/my_app``

```puppet
rsyslog::rule::data_source { 'new_input':
  rule => @(EOM)
    input(type="imfile"
      File="/opt/log/my_app"
      StateFile="my_app"
      Tag="my_app"
      Facility="local6"
      Severity="notice"
    )
    |EOM
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::data_source` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `String`

The Rsyslog ``EXPRESSION`` to filter on

### rsyslog::rule::drop

Add a rule to drop content

In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellanious Rules
  * Local Rules

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

The filename that you will be dropping into place.

#### Examples

##### Drop Logs Matching ``^.*bad_stuff.*$``

```puppet
rsyslog::rule::drop { 'drop_bad_stuff':
  rule => 're_match($msg, '^.*bad_stuff.*$')'
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::drop` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `String`

The Rsyslog ``EXPRESSION`` to filter on

### rsyslog::rule::local

Add a rule targeting writing local system logs

**NOTE:** Any option that is not explicitly documented here matches the
``ruleset`` options in the Rsyslog documentation.

In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellaneous Rules
  * Local Rules

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

#### Examples

##### Capture OpenLDAP Logs Then Stop Processing

```puppet
rsyslog::rule::local { 'collect_openldap':
  rule            => "prifilt('local4.*')",
  target_log_file => '/var/log/slapd.log',
  stop_processing => true
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::local` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `Optional[String]`

The Rsyslog ``EXPRESSION`` to filter on

* **NOTE:** Do **NOT** include the leading ``if/then``
    * Correct:   ``rule => "prifilt('*.*')"
    * Incorrect: ``rule => "if prifilt('*.*') then"``

* This **must** be set if ``$content`` is left empty

Default value: `undef`

##### `target_log_file`

Data type: `Optional[Stdlib::Absolutepath]`

The target log file that omfile will be writing to

* This **must** be set if ``$dyna_file`` is left empty

Default value: `undef`

##### `stop_processing`

Data type: `Boolean`

Do not forward logs to any further ``ruleset``s after processing this ``ruleset``

Default value: `false`

##### `dyna_file`

Data type: `Optional[String]`

Set a ``dynamic`` filename using the property replacer rules

* **NOTE:** If you make this the filename path itself, a template will
  automatically be created for you. Otherwise, you must make sure to have a
  rsyslog template in place and pass the **name of the template** to this
  option

* Rsyslog templates can be created using the ``rsyslog::template::*``
  defined types

Default value: `undef`

##### `template`

Data type: `Optional[String]`



Default value: `undef`

##### `dyna_file_cache_size`

Data type: `Integer[0]`



Default value: 10

##### `zip_level`

Data type: `Integer[0,9]`



Default value: 0

##### `very_robust_zip`

Data type: `Boolean`



Default value: `true`

##### `flush_interval`

Data type: `Integer[0]`



Default value: 0

##### `async_writing`

Data type: `Boolean`



Default value: `false`

##### `flush_on_tx_end`

Data type: `Boolean`



Default value: `true`

##### `io_buffer_size`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `dir_owner`

Data type: `Optional[String]`



Default value: `undef`

##### `dir_owner_num`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `dir_group`

Data type: `Optional[String]`



Default value: `undef`

##### `dir_group_num`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `file_owner`

Data type: `Optional[String]`



Default value: `undef`

##### `file_owner_num`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `file_group`

Data type: `Optional[String]`



Default value: `undef`

##### `file_group_num`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `file_create_mode`

Data type: `String`



Default value: '0644'

##### `dir_create_mode`

Data type: `String`



Default value: '0700'

##### `fail_on_chown_failure`

Data type: `Boolean`



Default value: `true`

##### `create_dirs`

Data type: `Boolean`



Default value: `true`

##### `sync`

Data type: `Boolean`



Default value: `false`

##### `sig_provider`

Data type: `Optional[String]`



Default value: `undef`

##### `cry_provider`

Data type: `Optional[String]`



Default value: `undef`

##### `queue_filename`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### `queue_spool_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### `queue_size`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_dequeue_batch_size`

Data type: `Integer[0]`



Default value: 16

##### `queue_max_disk_space`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_high_watermark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_low_watermark`

Data type: `Integer[0]`



Default value: 2000

##### `queue_full_delay_mark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_light_delay_mark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_discard_mark`

Data type: `Integer[0]`



Default value: 9750

##### `queue_discard_severity`

Data type: `Integer[0]`



Default value: 8

##### `queue_checkpoint_interval`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_sync_queue_files`

Data type: `Boolean`



Default value: `false`

##### `queue_type`

Data type: `Enum['FixedArray','LinkedList','Direct','Disk']`



Default value: 'Direct'

##### `queue_worker_threads`

Data type: `Integer[0]`



Default value: 1

##### `queue_timeout_shutdown`

Data type: `Integer[0]`



Default value: 0

##### `queue_timeout_action_completion`

Data type: `Integer[0]`



Default value: 1000

##### `queue_timeout_enqueue`

Data type: `Integer[0]`



Default value: 2000

##### `queue_timeout_worker_thread_shutdown`

Data type: `Integer[0]`



Default value: 60000

##### `queue_worker_thread_minimum_messages`

Data type: `Integer[0]`



Default value: 100

##### `queue_max_file_size`

Data type: `String`



Default value: '1m'

##### `queue_save_on_shutdown`

Data type: `Boolean`



Default value: `false`

##### `queue_dequeue_slowdown`

Data type: `Integer[0]`



Default value: 0

##### `queue_dequeue_time_begin`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_dequeue_time_end`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `content`

Data type: `Optional[String]`

the **entire* content of the rsyslog::rule

* If you do not specify this, ``$rule`` is a required variable

* If you do specify this, ``$rule`` will be ignored

Default value: `undef`

### rsyslog::rule::other

Adds an arbitrary rule

The main reason to use this is to ensure proper ordering in the stack. If you
want to insert a rule anywhere, use the ``$rsyslog::rule`` Defined Type

In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellaneous Rules
  * Local Rules

fine: rsyslog::rule::other

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

The filename that you will be dropping into place.

#### Examples

##### Send All ``local0`` Messages to ``1.2.3.4`` via TCP

```puppet
rsyslog::rule::other { 'send_local0_away':
  rule =>  "if prifilt('local0.*') then @@1.2.3.4"
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::other` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `String`

The Rsyslog ``EXPRESSION`` to filter on

### rsyslog::rule::remote

Adds a rule to send messages to a remote system

In general, the order will be:

  * Data Source Rules
  * Console Rules
  * Drop Rules
  * Remote Rules
  * Other/Miscellaneous Rules
  * Local Rules

If you wish to use TLS for forward RSyslog messages, you **MUST** configure it
via ``rsyslog::config``. Current EL versions of RSyslog 7 do not properly
support individual TLS settings via rulesets.

------------------------------------------------------------------------

> **WARNING**
>
> If possible, this module will take pains to prevent adding a target that is
> equivalent to the current system to prevent syslog loops.
>
> Unfortunately, there is **no** foolproof method for getting this correct
> 100% of the time so please take care when setting your destination targets.
>
> **WARNING**

------------------------------------------------------------------------

 * This **must** be set if ``$content`` is left empty

* **See also**
https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/System_Administrators_Guide/s1-basic_configuration_of_rsyslog.html
Red Hat Basic Rsyslog Configuration
http://www.rsyslog.com/doc/expression.html
Expressions in Rsyslog
http://www.rsyslog.com/doc/rainerscript.html
RainerScript Documentation

#### Examples

##### Send All ``local0`` Messages to ``1.2.3.4`` via TCP

```puppet
rsyslog::rule::remote { 'send_local0_away':
  rule        => "prifilt('local0.*')",
  log_servers => ['1.2.3.4']
}
```

#### Parameters

The following parameters are available in the `rsyslog::rule::remote` defined type.

##### `name`

Data type: `String`

The filename that you will be dropping into place

##### `rule`

Data type: `Optional[String]`

The Rsyslog ``EXPRESSION`` to filter on

* This should only be the matching part of the expression, the remaining
  parameters take care of ensuring that the material is properly routed.

* **NOTE:** Do **NOT** include the leading ``if/then``
    * Correct:   ``rule => "prifilt('*.*')"
    * Incorrect: ``rule => "if prifilt('*.*') then"``

Default value: `undef`

##### `stop_processing`

Data type: `Boolean`

Do not forward logs to any further ``ruleset``s after processing this ``ruleset``

Default value: `false`

##### `template`

Data type: `Optional[String]`

The template that should be used to format the content

Default value: `undef`

##### `dest`

Data type: `Simplib::Netlist`

If filled, logs matching ``$rule`` will be sent to **all hosts** in this Array.

* **WARNING:** If using this, do **NOT** add a destination to your ``rule``

Default value: []

##### `dest_type`

Data type: `Enum['tcp','udp','relp']`

The destination type for all entries in ``$dest``

* At this time, if you wish to have different types per destination, you
  will need to craft your own ruleset and leave ``$dest`` empty.

Default value: 'tcp'

##### `failover_log_servers`

Data type: `Simplib::Netlist`

The listed systems will be used as failover servers for all logs matching
this ``rule``

* Uses ``$dest_type`` above

Default value: []

##### `tcp_framing`

Data type: `Enum['traditional','octet-counted']`



Default value: 'traditional'

##### `zip_level`

Data type: `Integer[0,9]`



Default value: 0

##### `max_error_messages`

Data type: `Integer[0]`



Default value: 5

##### `compression_mode`

Data type: `Enum['none','single','stream:always']`



Default value: 'none'

##### `compression_stream_flush_on_tx_end`

Data type: `Boolean`



Default value: `true`

##### `rebind_interval`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `action_resume_interval`

Data type: `Integer[0]`



Default value: 30

##### `action_resume_retry_count`

Data type: `Integer[-1]`



Default value: -

##### `stream_driver`

Data type: `Optional[String]`

This is overridden by the ``rsyslog::config::default_net_stream_driver``

* EL versions of Rsyslog 7 do not support this properly in rulesets but it
  may be specified

Default value: `undef`

##### `stream_driver_mode`

Data type: `Integer[0]`

This is overridden by the ``rsyslog::config::action_send_stream_driver_mode``

* EL versions of Rsyslog 7 do not support this properly in rulesets but it
  may be specified

Default value: 1

##### `stream_driver_auth_mode`

Data type: `String`

This is overridden by the ``rsyslog::config::action_send_stream_driver_auth_mode``

* EL versions of Rsyslog 7 partially support this in rulesets and it may
  have some effect

Default value: 'x509/name'

##### `stream_driver_permitted_peers`

Data type: `String`

This is overridden by the ``rsyslog::config::action_send_stream_driver_permitted_peers``

* EL versions of Rsyslog 7 partially support this in rulesets and it may
  have some effect

Default value: "*.${::domain}"

##### `resend_last_msg_on_reconnect`

Data type: `Boolean`



Default value: `true`

##### `udp_send_to_all`

Data type: `Boolean`



Default value: `false`

##### `queue_filename`

Data type: `Optional[String]`



Default value: `undef`

##### `queue_spool_directory`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### `queue_size`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_dequeue_batch_size`

Data type: `Integer[0]`



Default value: 16

##### `queue_max_disk_space`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_high_watermark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_low_watermark`

Data type: `Integer[0]`



Default value: 2000

##### `queue_full_delay_mark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_light_delay_mark`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_discard_mark`

Data type: `Integer[0]`



Default value: 9750

##### `queue_discard_severity`

Data type: `Integer[0]`



Default value: 8

##### `queue_checkpoint_interval`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_sync_queue_files`

Data type: `Boolean`



Default value: `false`

##### `queue_type`

Data type: `Enum['LinkedList','FixedArray','Direct','Disk']`



Default value: 'LinkedList'

##### `queue_worker_threads`

Data type: `Integer[0]`



Default value: 1

##### `queue_timeout_shutdown`

Data type: `Integer[0]`



Default value: 0

##### `queue_timeout_action_completion`

Data type: `Integer[0]`



Default value: 1000

##### `queue_timeout_enqueue`

Data type: `Integer[0]`



Default value: 2000

##### `queue_timeout_worker_thread_shutdown`

Data type: `Integer[0]`



Default value: 60000

##### `queue_worker_thread_minimum_messages`

Data type: `Integer[0]`



Default value: 100

##### `queue_max_file_size`

Data type: `String`



Default value: '1m'

##### `queue_save_on_shutdown`

Data type: `Boolean`



Default value: `true`

##### `queue_dequeue_slowdown`

Data type: `Integer[0]`



Default value: 0

##### `queue_dequeue_time_begin`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `queue_dequeue_time_end`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### `content`

Data type: `Optional[String]`

the **entire* content of the rsyslog::rule

* If you do not specify this, ``$rule`` is a required variable

* If you do specify this, ``$rule`` will be ignored

Default value: `undef`

### rsyslog::template::list

Add a template list to the rsyslog configuration file.

RSyslog list templates can contain properties and constants. In order to
capture this functionality, we have opted for making a hash of these. The
Hash will be ordered as given to the content variable.

#### Examples

##### Content Settings

```puppet
$content_hash = {
  'constant' => 'values="Syslog MSG is: \'"',
  'property' => 'name="msg"'
}

rsyslog::template::list { 'example_list':
  $content => $content_hash
}

### Produces:

template(name="example_list" type="list") {
  constant(value="Syslog MSG is: '")
  property(name="msg")
}
```

#### Parameters

The following parameters are available in the `rsyslog::template::list` defined type.

##### `name`

Data type: `String`

The literal name (not path) of the ``file`` that will be written

##### `content`

Data type: `Hash[String,String,1]`

The rsyslog list content that you wish to add to the system, as a Hash

### rsyslog::template::plugin

Add template plugins to the rsyslog configuration file.

**NOTE:** Plugins are **as-is**. This means that you will only supply the
plugin name and assume that the plugin has already been loaded by RSyslog.

#### Examples

##### Adding the ``my_plugin`` Plugin to the System

```puppet
rsyslog::template::string { 'example_plugin':
  $plugin => 'my_plugin'
}

### Produces:

template(name="example_plugin" type="plugin" plugin="my_plugin")
```

#### Parameters

The following parameters are available in the `rsyslog::template::plugin` defined type.

##### `name`

Data type: `String`

The literal name of the ``file`` (not the full path) that will be used

##### `plugin`

Data type: `String`

The rsyslog plugin content that you wish to add to the system

* This is provided, without formatting, directly into the target file

### rsyslog::template::string

Add template strings to the rsyslog configuration

You'll need to write the entire template line due to the complexity of the
rsyslog configuration parameters.

Leading spaces will be removed.

#### Examples

##### Template String

```puppet
rsyslog::template::string { 'example':
  $content => '/var/log/hosts/%HOSTNAME%/example.log'
}

### Produces:

template(name="example" type="string" string="/var/log/hosts/%HOSTNAME%/example.log")
```

#### Parameters

The following parameters are available in the `rsyslog::template::string` defined type.

##### `name`

Data type: `String`

The literal name of the ``file`` (not file path) that will be used

##### `string`

Data type: `String`

The rsyslog template string that you wish to add to the system

* This is fed, without formatting, directly into the target file

### rsyslog::template::subtree

Add template subtrees to the rsyslog configuration

You'll need to write the entire subtree line due to the complexity of the
rsyslog configuration parameters.

#### Examples

##### Subtree (From the Official RSyslog Docs)

```puppet
rsyslog::template::subtree { 'example_subtree':
  $variables => ['$!usr!tp12!msg = $msg;', '$!usr!tp12!dataflow = field($msg, 58, 2);'],
  $subtree   => '$!usr!tp12'
}

### Produces:

set $!usr!tp12!msg = $msg;
set $!usr!tp12!dataflow = field($msg, 58, 2);
template(name="example" type="subtree" subtree="$!usr!tp12")
```

#### Parameters

The following parameters are available in the `rsyslog::template::subtree` defined type.

##### `name`

Data type: `String`

The literal name of the ``file`` (not a path) that will be used

##### `subtree`

Data type: `String`

The rsyslog subtree content that you wish to add to the system

* This is fed, without formatting, directly into the subtree parameter

##### `variables`

Data type: `Array[String]`

Variables to be set **prior** to the template being created

Default value: []

