# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

_Public Classes_

* [`simp_ipa`](#simp_ipa): Placeholder class for now
* [`simp_ipa::client::install`](#simp_ipaclientinstall): Run ipa-client-install on puppet clients

_Private Classes_

* `simp_ipa::client::packages`: Class to contain packages required for simp::simp_ipa::install

## Classes

### simp_ipa

Placeholder class for now

### simp_ipa::client::install

Run ipa-client-install on puppet clients

* **Note** Not all parameters here are required. If the DNS is properly configured
on the host, nothing needs to be set besides $password. Be sure to read the
man page in ipa-client-install or the help for guidance

* **See also**
ipa-client-install(1)

#### Parameters

The following parameters are available in the `simp_ipa::client::install` class.

##### `ensure`

Data type: `Enum['present','absent']`

'present' to add host to an IPA domain, 'absent' to remove

##### `ip_address`

Data type: `Optional[Array[Simplib::IP]]`

IP address of host being connected

Default value: `undef`

##### `hostname`

Data type: `Optional[Simplib::Hostname]`

Hostname of the host being connected

Default value: `undef`

##### `password`

Data type: `Optional[String]`

The password used for joining. The password can be of one of two types:
  * If $principal is set, this is the password relating to
    that administrative user
  * A one time password. A host-based one-time-password generated by
    ``ipa host-add`` or the GUI

Default value: `undef`

##### `principal`

Data type: `Optional[String]`

The administrative user krb5 principal that $password relates to, if the $password is not
a one time password

Default value: `undef`

##### `server`

Data type: `Optional[Array[Simplib::Hostname]]`

IPA server to connect to

Default value: `undef`

##### `domain`

Data type: `Optional[Simplib::Hostname]`

IPA Domain

Default value: `undef`

##### `realm`

Data type: `Optional[String]`

IPA Realm

Default value: `undef`

##### `no_ac`

Data type: `Boolean`

Run without authconfig, defaults to true, appropriate on systems
using ``simp/pam``

Default value: `true`

##### `install_options`

Data type: `Hash`

Hash of other options for the ``ipa-client-install`` command.  Any key
here that is also a class parameters will be overwritten with the value
of the corresponding class parameter. Also, if the option doesn't need a
value, (e.g., the `debug` option), just set the value of the setting to
Undef or nil in Hiera.

@see ``ipa-client-install --help``

Default value: {}

##### `ipa_client_ensure`

Data type: `String`

Ensure attribute of the package resource managing the ``ipa-client`` package

Default value: simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })

##### `admin_tools_ensure`

Data type: `String`

Ensure attribute of the package resource managing the ``ipa-admintools``
package. Only applicable on EL6.

Default value: simplib::lookup('simp_options::package_ensure', { 'default_value' => 'installed' })

##### `ntp_server`

Data type: `Optional[Array[Simplib::Host]]`



Default value: `undef`

