# simp-cli

A cli interface to configure SIMP and simplify administrative tasks.

## Usage

```bash
simp COMMAND [OPTIONS]
```

**NOTE:** The `simp` cli command is intended to be run from a SIMP-managed OS.

### Commands
#### Configuration
##### `bootstrap`
Bootstraps a SIMP system (requires configuration data generated by `simp config`).

**NOTE:** If you have an existing 'production' environment it will be backed up and
mapped to a 'simp' environment when bootstrap is run.

##### `config`
Creates SIMP configuration files with an interactive questionnaire.


#### Adminstration
##### `doc`
Displays SIMP documentation in elinks.

##### `passgen`
Controls user passwords.

#### Recently removed
##### `cleancerts` _- use `puppet cert clean CERTNAME` instead_
Revokes and removes Puppet certificates from a list of hosts.

##### `runpuppet`_- use [mcollective](http://puppetlabs.com/mcollective) instead_
Runs puppet on a list of hosts.


##### `puppeteval` _- use `puppet agent --evaltrace` instead_
Gathers metrics information on Puppet runs.


## License
See [LICENSE](LICENSE)
